import asyncio
import sse
import asyncio_mongo as mongodb


class Handler(sse.Handler):
    @asyncio.coroutine
    def handle_request(self):
        mongo = yield from mongodb.Connection.create()
        collection = mongo.digi.pubsub
        cursor, docs = yield from collection.find(tailable=True, await_data=True)
        while True:
            for doc in docs:
                #print(doc)
                doc = {"post":doc.get("post"),
                       "user":doc.get("user"),
                       "thread":doc.get("thread")}
                self.send(doc)
            cursor, docs = yield from cursor
            #yield from asyncio.sleep(0.1)


start_server = sse.serve(Handler, 'localhost', 8888)
asyncio.get_event_loop().run_until_complete(start_server)
asyncio.get_event_loop().run_forever()
